.equ formatter blc_log_buffer_100+8
.equ clock_addr blc_log_buffer_100+0x10
.equ clock_area clock_addr+4
.equ clock_color clock_area+8
.equ clock_font clock_area+0xC
.equ mobile_skins 0x103A32F0
.equ seem_4a 0x61F

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;hex (right side):
;0000 0000 0015 000E 0015 0000 0022 000E 0023 0000 0032 000E 0025 0000 0031 000E 0032 0000 0043 000E 0043 0000 0054 000E 0054 0000 0063 000E 008C 0000 00AE 0010 0063 0000 0075 000E 0075 0000 008A 000E
;                                                                                                                                            !8 - clock_area --!                      
;dec (right side):
;1 0 0 21 14
1 21 0 34 14
1 35 0 50 14
1 37 0 49 14
1 50 0 67 14
1 67 0 84 14
1 84 0 99 14
1 140 0 174 16
1 99 0 117 14
1 117 0 138 14
;									                  !8 - clock_area!
;.patchcoment "status icons for skins"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.code  16

.start  0x1072F884
        BL      update_clock_in_status_bar
.patchcoment "IdleSetClockStatus"

.start  0x1072F9D8					;"IdleSetClockStatus: Exit = %d"
        .string "ISE"
update_clock_in_status_bar:
        BX      PC
.code 32
        LDR     R12, =update_clock_in_status_bar_ARM
        BX      R12
.patchcoment "update_clock_in_status_bar"

.code 32

.start  0x102DAA00
        B       my_setSkin__12ThemeManager
return_setSkin__12ThemeManager:
.patchcoment "setSkin__12ThemeManagerFUsUcSc"

.start  0x1012FABC					;".HTTP : After the parsing of headers ..."
        .string "AH
"

my_setSkin__12ThemeManager:
        BL      read_CLOCK_TABLE_ARM
        MOV	R0, R9
        B       return_setSkin__12ThemeManager
.patchcoment "my_setSkin__12ThemeManager"

read_CLOCK_TABLE_ARM:
        LDR     R12, =read_CLOCK_TABLE+1
        BX      R12
.patchcoment "read_CLOCK_TABLE_ARM"

.code 16

read_CLOCK_TABLE:
        PUSH    {R0-R7,LR}
        SUB     SP, #0x214 ;(4+(6+2+255+1)*2)
        LDR     R6, =clock_addr
	MOV	R5, #0x0				;clock_addr_init
        MOV     R2, #0x10				;DL_FS_OWNER_PROFILES
        MOV     R1, #0x0				;DL_FS_READ_MODE

        ADD     R0, SP, #0x4
        BL      get_file_name
        
        BL      _Ven_TT_L__DL_FsOpenFile

        MOV     R7, R0					;file_handle
        LDR     R3, =0x0000FFFF				;DL_FS_HANDLE_INVALID
        CMP     R7, R3
        BEQ     read_CLOCK_TABLE_exit			;   

        BL      _Ven_TT_L__DL_FsGetFileSize

        CMP     R0, #0x10
        BNE     read_CLOCK_TABLE_close_file		;   

        MOV     R3, R7					;file_handle
        ADD     R2, SP, #0x0
        STR     R2, [SP]				;elements_written
        MOV     R2, #0x1				;count
        MOV     R1, #0x10				;size

        MOV     R0, #0x4
        ADD     R0, R6, R0				;buffer
        BL      _Ven_TT_L__DL_FsReadFile

        CMP     R0, #0x0
        BNE     read_CLOCK_TABLE_close_file		;   

        MOV     R5, #0x4
        ADD     R5, R6, R5

read_CLOCK_TABLE_close_file:
        MOV     R0, R7					;file_handle
        BL      _Ven_TT_L__DL_FsCloseFile

read_CLOCK_TABLE_exit:
        STR     R5, [R6,#0x0]
        ADD     SP, #0x214 ;(4+(6+2+255+1)*2)
        POP     {R0-R7}
        POP     {R3}
        BX      R3
.patchcoment "read_REGION_TABLE"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.code 32

.start  0x1036EA30
        B       draw_clock_in_status_line
return_fillTheStatusArea__13StatusManager:
.patchcoment "fillTheStatusArea__13StatusManager (StatusManager::fillTheStatusArea)"

.start  0x102538C0					;"Welcome"

.code 16

get_file_name:
        PUSH    {R1-R7,LR}
        MOV     R7, R0
        LDR     R1, =mobile_skins
        BL      _Ven_TA_S__u_strcpy

        BL      _Ven_TA_S__UIS_GetCurrentSkinIndex	;   

        BL      _Ven_TA_S__UIS_GetSkinName
        
        MOV     R1, R0
        MOV     R0, R7
        BL      _Ven_TA_S__u_strcat

        ADR     R1, _CLOCK_TABLE_name
        MOV     R0, R7
        BL      _Ven_TA_S__u_strcat

        MOV     R0, R7
        POP     {R1-R7,PC}
.patchcoment "get_file_name"

.align 2
_CLOCK_TABLE_name:
	.hex	002F 0043 004C 004F 0043 004B 005F 005400410042004C0045 0000
.align 1
.patchcoment "/CLOCK_TABLE"

.code 32

draw_clock_in_status_line:
        STMFD   SP!, {R0-R12}
        SUB     SP, SP, #0x110
        LDR     R0, =activeDisplayID__6Dialog
        LDRB    R0, [R0,#0x0]
        LDR     R1, =statusAreaFlag__6Dialog
        LDRB    R1, [R1,#0x0]
        ORRS    R0, R0, R1
        BNE     draw_clock_in_status_line_exit		;   

        LDR     R1, =clock_addr
	LDR	R1, [R1]

	CMP	R1, #0x0
	BEQ	draw_clock_in_status_line_exit		;  CLOCK_TABLE 

        LDR     R1, =clock_area	
        LDRH    R1, [R1,#4]
        LDRH    R0, [R4,#4]

        CMP     R0, R1
        BEQ     loc_44
        LDRH    R0, [R4,#4]
        CMP     R0, #0xAF
        BNE     draw_clock_in_status_line_exit		;   

loc_44:
        ADD     R2, SP, #0x44
        MOV     R1, #0x2E				;
        LDR     R0, =theStatusManager
        BL      getHighestPriorityStatus__13StatusManagerFUcP10UI_CONTENT
        CMP     R0, #0x0
        BNE     draw_clock_in_status_line_exit		;   
        MOV     R2, #8
        LDR     R1, =clock_area
        ADD     R0, SP, #0x28
        BL      _Ven_AA_L____rt_memcpy_0
        LDR     R0, =formatter
        LDR     R0, [R0,#0x0]
        CMP     R0, #0
        BNE     draw_clock_in_status_line_formatter_exists
        MOV     R0, #0x0
        BL      __ct__16DisplayFormatterFv
        LDR     R1, =formatter
        STR     R0, [R1,#0x0]
draw_clock_in_status_line_formatter_exists:
        MOV     R1, #0x3A				;
        LDR     R0, =colmgr
        BL      getColor__12ColorManagerFUc
        STR     R0, [SP,#0x38]

	LDR	R0, =clock_color			;
	LDR	R0, [R0]

        STR     R0, [SP,#0x34]
        MOV     R0, #0
        STRB    R0, [SP,#0x31]
        MOV     R0, #0
        STRB    R0, [SP,#0x32]
        MOV     R0, #0x11
        STRB    R0, [SP,#0x30]
        MOV     R0, #0
        STRB    R0, [SP,#0x33]

        LDR     R0, my_uis_color			;
        STR     R0, [SP,#0x24]
        STR     R0, [SP,#0x20]
        MOV     R3, #0x0
        MOV     R2, #0x1
        LDR     R0, =activeDisplayID__6Dialog
        LDRB    R1, [R0,#0x0]
        MOV     R0, #0x1
        ADD     R12, SP, #0x10
        STMIA   R12, {R0-R3}

	LDR	R0, =clock_font				;
	LDRB	R1, [R0, #0x3]

        ADD     R0, SP, #0x30
        STMEA   SP, {R0-R3}
        ADD     R3, SP, #0x28
        ADD     R2, SP, #0x44
        LDR     R0, =formatter
        LDR     R1, [R0,#0x0]
        ADD     R0, SP, #0x20
        BL      drawOneLine__16DisplayFormatterFP10UI_CONTENTRC24tag_DAL_GRAPHIC_REGION_TR28UIS_GRAPHIC_RECTANGLE_ATTRIBUcT4P23tag_DAL_GRAPHIC_POINT_TScT4T7PUsP4Text

draw_clock_in_status_line_exit:
        ADD     SP, SP, #0x110
        LDMFD   SP!, {R0-R12}

	MOV	R0, #0x0
        B       return_fillTheStatusArea__13StatusManager
.patchcoment "draw_clock_in_status_line"

.align 2

my_uis_color:
	DCD	0x00000000

.align 1

update_clock_in_status_bar_ARM:
        STMFD   SP!, {R0-R12,LR}
        SUB     SP,#0xC
        LDR     R0, =activeDisplayID__6Dialog
        LDRB    R0, [R0,#0x0]
        LDR     R1, =statusAreaFlag__6Dialog
        LDRB    R1, [R1,#0x0]
        ORRS    R0, R0, R1
        BNE     update_clock_in_status_bar_ARM_exit

        LDR     R1, =clock_addr
	LDR	R1, [R1]
	CMP	R1, #0x0
	BEQ	update_clock_in_status_bar_ARM_exit	;  CLOCK_TABLE 

        MOV     R2, #8
        LDR     R1, =clock_area
        ADD     R0, SP, #4
        BL      _Ven_AA_L____rt_memcpy_0
        LDR     R0, =activeDisplayID__6Dialog
        LDRB    R3, [R0,#0x0]
        MOV     R2, #0
        ADD     R1, SP, #4
        LDR     R0, =theStatusManager
        BL      fillTheStatusArea__13StatusManagerFR24tag_DAL_GRAPHIC_REGION_TPUsUc

update_clock_in_status_bar_ARM_exit:
        ADD     SP,#0xC
        LDMFD   SP!, {R0-R12,LR}
        BX      LR
.patchcoment "update_clock_in_status_bar"